unit MaskUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, Spin, ExtDlgs;

type
  TForm1 = class(TForm)
    Image1: TImage;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    SpinEdit4: TSpinEdit;
    SpinEdit5: TSpinEdit;
    SpinEdit6: TSpinEdit;
    SpinEdit7: TSpinEdit;
    SpinEdit8: TSpinEdit;
    BitBtn1: TBitBtn;
    SpinEdit9: TSpinEdit;
    SpinEdit10: TSpinEdit;
    SpinEdit11: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button1: TButton;
    BitBtn2: TBitBtn;
    OpenPictureDialog1: TOpenPictureDialog;
    procedure BitBtn1Click(Sender: TObject);
    procedure EffectCustom(var SrcBitmap: TBitmap);
    procedure Button1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private 錾 }
    MaskBits : array[0..8] of Smallint;
    Divisor,Bias:byte;
  public
    { Public 錾 }
    bank:TBitmap;
 //   newbank:TBitmap;
  end;

var
  Form1: TForm1;

implementation

uses
 EffectBass;

{$R *.dfm}

procedure TForm1.BitBtn1Click(Sender: TObject);
var
 bitmap:TBitmap;
begin
  if(bank=nil)then
  begin
   bank:=TBitmap.Create();
   bank.Assign(Image1.Picture.Bitmap);
  end;

  bitmap:=TBitmap.Create();
  MaskBits[0]:=self.SpinEdit1.Value;
  MaskBits[1]:=self.SpinEdit2.Value;
  MaskBits[2]:=self.SpinEdit3.Value;
  MaskBits[3]:=self.SpinEdit4.Value;
  MaskBits[4]:=self.SpinEdit5.Value;
  MaskBits[5]:=self.SpinEdit6.Value;
  MaskBits[6]:=self.SpinEdit7.Value;
  MaskBits[7]:=self.SpinEdit8.Value;
  MaskBits[8]:=self.SpinEdit11.Value;
  self.Divisor:=self.SpinEdit9.Value;
  self.Bias:=self.SpinEdit10.Value;

  bitmap.Assign(bank);
  self.EffectCustom(bitmap);
  Image1.Picture.Bitmap.Assign(bitmap);
end;

procedure TForm1.EffectCustom(var SrcBitmap: TBitmap);
var
  Row,Col,yRow,xCol,r,g,b,X,y,EAX: Integer;
  DestRow          : pRGBArray;
  SourceBits       : PPBits;
  _Height,_Width   : integer;
  DestBitmap  : TBitmap;
begin
 DestBitmap  :=TBitmap.Create;
 Set24bit(SrcBitmap,DestBitmap);
 _Height := SrcBitmap.height-1;
 _Width  := SrcBitmap.width-1;

   GetMem(SourceBits, SrcBitmap.Height * SizeOf(pRGBArray));
try
   for Row:= 0 to SrcBitmap.Height - 1 do  SourceBits[Row]:=SrcBitmap.Scanline[Row];

   For Row := 0 To _Height   do
   begin

        DestRow:=DestBitmap.ScanLine[Row];

        For Col := 0 To _Width do
        begin
            //-------------
            // 0 - 1 - 2
            //-------------
            // 3 - 4 - 5
            //-------------
            // 6 - 7 - 8
            //-------------
            R:=0;G:=0;B:=0; EAX:=0;
            for y:= -1 to 1 do
            begin
              for x:= -1 to 1 do
              begin
                 //Y
                 if      Row+(y)> _Height then
                  yRow:=_Height
                 else if Row+(y)< 0       then
                  yRow:=0
                 else
                   yRow:=Row+(y);
                 //X
                 if      Col+(x)> _Width  then  xCol:=_Width
                 else if Col+(x)< 0       then  xCol:=0
                 else
                   xCol:=Col+(x);

                 B:=B+(SourceBits[yRow][xCol].rgbtBlue*MaskBits[EAX]);
                 G:=G+(SourceBits[yRow][xCol].rgbtGreen*MaskBits[EAX]);
                 R:=R+(SourceBits[yRow][xCol].rgbtRed*MaskBits[EAX]);
                 inc(EAX);
              end;
            end;

           DestRow[Col].rgbtRed   :=Set255((R div Divisor)+Bias);
           DestRow[Col].rgbtGreen :=Set255((G div Divisor)+Bias);
           DestRow[Col].rgbtBlue  :=Set255((B div Divisor)+Bias);

       end;
    end;

  FreeMem(SourceBits); SourceBits:=nil;
  SrcBitmap.handle :=DestBitmap.ReleaseHandle;

  except
     if Assigned(SourceBits) then FreeMem(SourceBits);
  end;

  DestBitmap.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
 bitmap:TBitmap;
begin
   if(bank=nil)then
  begin
   bank:=TBitmap.Create();
   bank.Assign(Image1.Picture.Bitmap);
  end;

  bitmap:=TBitmap.Create();
  MaskBits[0]:=self.SpinEdit1.Value;
  MaskBits[1]:=self.SpinEdit2.Value;
  MaskBits[2]:=self.SpinEdit3.Value;
  MaskBits[3]:=self.SpinEdit4.Value;
  MaskBits[4]:=self.SpinEdit5.Value;
  MaskBits[5]:=self.SpinEdit6.Value;
  MaskBits[6]:=self.SpinEdit7.Value;
  MaskBits[7]:=self.SpinEdit8.Value;
  MaskBits[8]:=self.SpinEdit11.Value;
  self.Divisor:=self.SpinEdit9.Value;
  self.Bias:=self.SpinEdit10.Value;

  bitmap.Assign(Image1.Picture.Bitmap);
  self.EffectCustom(bitmap);
  Image1.Picture.Bitmap.Assign(bitmap);
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
 if(self.OpenPictureDialog1.Execute)then
 begin
  Image1.Picture.LoadFromFile(self.OpenPictureDialog1.FileName);
  if(bank=nil)then bank:=TBitmap.Create();
  bank.Assign(Image1.Picture);
 end;
end;

end.
