library cwconv;

uses
  SysUtils,
  Classes,
  windows,
  Graphics,
  convinf in 'convinf.pas',
  TextImages in 'TextImages.pas';

{$R *.res}

(*摜|C^̌`ɒu*)
function createImage(var bitmap:TBitmap):PCardinal;
var
 x:Integer;
 car:PCardinal;
 buffer:Pointer;
 stream:TMemoryStream;
begin
 stream:=TMemoryStream.Create();

 try
  bitmap.SaveToStream(stream);
  stream.Position:=0;
  x:=stream.Size;
  car:=PCardinal(GlobalAlloc(GPTR,x));
  buffer:=Pointer(car);
  stream.ReadBuffer(buffer^,x);
 finally
  stream.Free;
  bitmap.Free;
 end;

  result:=car;

end;

(*J[h[X̗v󂯎A摜|C^ŕԂ*)
function GetImage(fileName:PChar;var data:PCardinal):boolean;stdcall;
var
 bitmap:TBitmap;
 director:TImageDirector;
begin

 bitmap:=TBitmap.Create();
 bitmap.PixelFormat:=pf32bit;

 director:=TImageDirector.Create();
 director.basedir:=ExtractFileDir(fileName);
 director.loadImage(fileName,bitmap);
 if(bitmap.Width*bitmap.Height<>0)then
 begin
  bitmap.Transparent:=false;
  data:=createImage(bitmap);
  result:=true;
 end
 else
  result:=false;

 director.Free();

end;
(*GfB^[p̓ǂݍ݁EɑH*)
function GotImage(fileName:PChar;var data:PCardinal):boolean;stdcall;
var
 bitmap:TBitmap;
 director:TImageDirector;
begin

 bitmap:=TBitmap.Create();
 bitmap.PixelFormat:=pf32bit;

 director:=TImageDirector.Create();
 director.basedir:=ExtractFileDir(fileName);
 director.animation:=false;
 director.searched:=true;

 director.loadImage(fileName,bitmap);
 if(bitmap.Width*bitmap.Height<>0)then
 begin
  bitmap.Transparent:=false;
  data:=createImage(bitmap);
  result:=true;
 end
 else
  result:=false;

 director.Free();

end;

exports
GetImage name 'GetImage',
GotImage name 'GotImage';

begin
end.



