unit TempPosForms;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons,iniFiles, ComCtrls,convImages,Contnrs;

type

  TWPosInf =class(TObject)
  public
   inf:TPosinf;
 //  partsName:string;
  end;

  TConfigloader = class(TObject)
  public
   function loadConfig(fileName:string):TStrings;
//   destructor destroy();
  end;

  TTempPosForm = class(TForm)
    posListBox: TListBox;
    OKBB: TBitBtn;
    CancelBB: TBitBtn;
    Label3: TLabel;
    WidthEdit: TEdit;
    WidthUpDown: TUpDown;
    Label4: TLabel;
    HeightEdit: TEdit;
    HeightUpDown: TUpDown;
    Label5: TLabel;
    PosXEdit: TEdit;
    XUpDown: TUpDown;
    Label6: TLabel;
    PosYEdit: TEdit;
    YUpDown: TUpDown;
    transCheckBox: TCheckBox;
    procedure CancelBBClick(Sender: TObject);
    procedure OKBBClick(Sender: TObject);
    procedure posListBoxClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    function getPosInf():TPosInf;
    procedure setPosInf(inf:TPosInf);
    procedure setFileName(fileName:string);
  end;

var
  TempPosForm: TTempPosForm;

implementation

{$R *.dfm}



function TConfigloader.loadConfig(fileName:string):TStrings;
var
 ini:TIniFile;
 count:Integer;
 name,section:string;
 winf:TWPosInf;
const
 cell='CELL';
begin

 result:=TStringList.Create();

 if(fileExists(fileName))then
 begin
  ini:=TIniFile.Create(fileName);
  count:=0;
  section:=cell+IntToStr(count);
  
  while(ini.SectionExists(section)) do
  begin
   winf:=TWPosInf.Create();
   winf.inf.x:=ini.ReadInteger(section,'Left',0);
   winf.inf.y:=ini.ReadInteger(section,'Top',0);
   winf.inf.w:=ini.ReadInteger(section,'Width',0);
   winf.inf.h:=ini.ReadInteger(section,'Height',0);
   winf.inf.trans:=ini.ReadBool(section,'Masked',false);
   result.AddObject(ini.ReadString(section,'Name',''),winf);
   inc(count);
   section:=cell+IntToStr(count);
  end;

 end;

end;

procedure TTempPosForm.CancelBBClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TTempPosForm.OKBBClick(Sender: TObject);
begin
  ModalResult := mrOK;
end;

procedure TTempPosForm.setFileName(fileName:string);
var
 loader:TConfigloader;
 i:Integer;
 list:TStrings;
begin
 loader:=TConfigloader.Create();
 try
  list:=loader.loadConfig(fileName);
  self.posListBox.Clear;
  self.posListBox.Items.AddStrings(list);

  //for i:=0 to list.Count-1 do
 // begin

//  end;

 finally
  loader.Free();
 end;
end;

function TTempPosForm.getPosInf():TPosInf;
begin
 result.x:=self.XUpDown.Position;
 result.y:=self.YUpDown.Position;
 result.w:=self.WidthUpDown.Position;
 result.h:=self.HeightUpDown.Position;
 result.trans:=self.transCheckBox.Checked;
end;

procedure TTempPosForm.setPosInf(inf:TPosInf);
begin
 self.XUpDown.Position:=inf.x;
 self.YUpDown.Position:=inf.y;
 self.WidthUpDown.Position:=inf.w;
 self.HeightUpDown.Position:=inf.h;
 self.transCheckBox.Checked:=inf.trans;
end;

procedure TTempPosForm.posListBoxClick(Sender: TObject);
var
 winf:TWPosInf;
begin
 if(posListBox.Count>0)and(posListBox.ItemIndex>-1)then
 begin
  winf:=TWPosInf(posListBox.Items.Objects[posListBox.ItemIndex]);
  self.setPosInf(winf.inf);
 end;
end;

end.
