unit Firstloads;

interface

uses iniFiles,windows,sysUtils;

type

TFirstload = class(TObject)
 currentDir,seekFileName:string;
 function getFileName():string;
 constructor create();
end;

TCWload = class(TFirstLoad)
 seekValueName,seekSectionName:string;
 function getIniFileDirName(FileName:string):string;
end;

implementation

constructor TFirstLoad.create();
var
 p:PChar;
begin
 inherited;
 getMem(p,255);
 GetModuleFileName(0,p,255);
 currentDir:=ExtractFileDir(p);
 FreeMem(p,255);
end;

function TFirstLoad.getFileName():string;
var
 p:PChar;
 name:string;
begin

 if FileExists(currentDir+'\'+seekFileName)then
 begin
  result:=name+'\'+seekFileName;
 end
 else result:='';

end;

function TCWload.getIniFileDirName(FileName:string):string;
var
 ini:TIniFile;
 isload:boolean;
begin

 if FileExists(currentDir+'\'+FileName)then
 begin
  ini:=TIniFile.Create(currentDir+'\'+FileName);
  result:=ini.ReadString(seekSectionName,seekValueName,'');
  ini.Free();
  if(result<>'')then isload:=true
  else isload:=false;
 end
 else isload:=false;

 if not(isload)then
 if FileExists(currentDir+'\'+seekFileName)then
 begin
  result:=currentDir;

 end
 else result:='';

end;

end.
